%
% Easom function test
%
% what = 'f'  compute the Rosenbrock function
% what = 'Df' compute the Gradient of the Rosenbrock function
% what = 'DDf' compute the Hessian of the Rosenbrock function
%
function RES = Easom( what, XIN )

  if nargin > 1
    X = XIN(1,:) ;
    Y = XIN(2,:) ;
  end

  switch what
  case 'name'
    RES = 'Easom' ;
  case 'init'
    RES = [ 2 ; 1 ] ;
  case 'f'
    RES = cos(X) .* cos(Y) .* exp(-(X - pi) .^ 2 - (Y - pi) .^ 2);
  case {'F','Df'}
    t1  = sin(X) ;
    t2  = cos(Y) ;
    t4  = X - pi ;
    t5  = t4 .^ 2 ;
    t6  = Y - pi ;
    t7  = t6 .^ 2 ;
    t9  = exp(-t5 - t7) ;
    t11 = cos(X) ;
    t12 = t11 .* t2 ;
    t16 = sin(Y) ;
    RES = [ t1 .* t2 .* t9 + 2 .* t12 .* t4 .* t9; ...
            t11 .* t16 .* t9 + 2 .* t12 .* t6 .* t9] ;
  case {'JF','DDf'}
    t1 = cos(X);
    t2 = cos(Y);
    t3 = t1 .* t2;
    t4 = X - pi;
    t5 = t4 .^ 2;
    t6 = Y - pi;
    t7 = t6 .^ 2;
    t9 = exp(-t5 - t7);
    t11 = 3 .* t3 .* t9;
    t12 = sin(X);
    t13 = t12 .* t2;
    t14 = -2 .* t4 .* t9;
    t21 = sin(Y);
    t24 = -2 .* t6 .* t9;
    t26 = t1 .* t21;
    t31 = -t12 .* t21 .* t9 + t13 .* t24 + t26 .* t14 - 4 .* t3 .* t4 .* t6 .* t9;
    RES = [ t11 + 2 .* t13 .* t14 - 4 .* t3 .* t4 .^ 2 .* t9, t31; ...
            t31, t11 + 2 .* t26 .* t24 - 4 .* t3 .* t6 .^ 2 .* t9 ] ;
  otherwise
    error(['Rosenbrock bad argument:' what]) ;
  end ;
end