%
% Newton method for non linear system
%
function varargout = Newton( F, JF, x0, epsi )

  x = x0 ;

  % if required save the computed iteration
  if nargout == 2
    varargout{1} = [] ;
    varargout{2} = [] ;
  end ;

  for k=1:1000

    disp(k)

    % if required save the computed iteration
    if nargout == 2
      varargout{1} = [varargout{1}, norm(feval( F, x ),inf)]  ;
      varargout{2} = [varargout{2}, x ] ;
    end ;

    % compute step size
    Fx  = feval( F,  x ) ;
    JFx = feval( JF, x ) ;
    
    % check for bad termination
    rc = rcond(JFx) ;
    if ~ isfinite(rc) | rc < 1E-10
      disp('Newton: bad termination');
      return ;
    end ;

    d   = JFx \ Fx ;
    x   = x - d ;


    % check for termination
    if norm( d, inf ) < epsi
      break ;
    end ;

  end ;

  if nargout == 1
    varargout{1} = x ;
  end ;

end
