%
% Rosenbrock test
%
% what = 'f'   compute the log of Rosenbrock function
% what = 'Df'  compute the Gradient of the log of Rosenbrock function
%
function RES = RosenbrockLog( what, XIN )
  X     = XIN(1,:) ;
  Y     = XIN(2,:) ;
  YX    = (Y-X.^2) ;
  fbase = 100*YX.^2+(X-1).^2 ;
  switch what
  case 'f'
    RES = log(1+fbase) ;
  case 'Df'
    RES = [ 2*(X-1) - 400*YX.*X ; 200*YX ]./(1+fbase) ;
  otherwise
    error(['RosenbrockLog bad argument:' what]) ;
  end ;
end