%
% Rosenbrock test
%
% what = 'f'  compute the Rosenbrock function
% what = 'Df' compute the Gradient of the Rosenbrock function
% what = 'DDf' compute the Hessian of the Rosenbrock function
%
function RES = Wood( what, X )
  
  if nargin > 1
    x1 = X(1,:) ;
    x2 = X(2,:) ;
    x3 = X(3,:) ;
    x4 = X(4,:) ;
  end

  switch what
  case 'name'
    RES = 'Wood' ;
  case 'init'
    RES = [-3;-1;-3;-1] ;
  case 'f'
    t1  = x2 .^ 2;
    t3  = x1 .^ 2;
    t6  = t3 .^ 2;
    t9  = x4 .^ 2;
    t11 = x3 .^ 2;
    t14 = t11 .^ 2;
    RES = 0.1101000000e3 * t1 - 0.200e3 * x2 * t3 + 0.100e3 * t6 + t3 - 0.2e1 * x1 ...
        + 0.42e2 + 0.1001000000e3 * t9 - 0.180e3 * x4 * t11 + 0.90e2 * t14 ...
        - 0.2e1 * x3 + t11 - 0.40e2 * x2 - 0.40e2 * x4 + 0.1980000000e2 * x2 .* x4;
  case {'F','Df'}
    t3  = x1 .^ 2 ;
    t14 = x3 .^ 2;
    RES = [-400 * x1 .* x2 + 400 * t3 .* x1 + 2 * x1 - 2; ...
           (0.2202000000e3 * x2 - 0.200e3 * t3 - 0.40e2 + 0.1980000000e2 * x4); ...
           (-0.360e3 * x3 .* x4 + 0.360e3 * t14 .* x3 - 0.2e1 + 0.2e1 * x3); ...
           (0.2002000000e3 * x4 - 0.180e3 * t14 - 0.40e2 + 0.1980000000e2 * x2) ] ;
  case {'JF','DDf'}
    t1  = x1 .^ 2;
    t5  = 400 * x1;
    t6  = x3 .^ 2 ;
    t10 = 360 * x3;
    RES = [ 1200 * t1 - 400 * x2 + 2, -t5, 0, 0; ...
           -t5, 0.2202000000e3, 0, 0.1980000000e2; ...
           0, 0, 1080 * t6 - 360 * x4 + 2,-t10; ...
           0, 0.1980000000e2, -t10, 0.2002000000e3 ] ;
  otherwise
    error(['Wood bad argument:' what]) ;
  end ;
end
